package oracle.support.model;

import java.io.Serializable;
import javax.persistence.*;
import org.eclipse.persistence.annotations.Cache;
import org.eclipse.persistence.annotations.CacheCoordinationType;



/**
 * Entity implementation class for Entity: TestEntity
 *
 */
@Entity
@Table(name = "TEST_ENTITIES")
@Cache(coordinationType=CacheCoordinationType.SEND_OBJECT_CHANGES)
public class TestEntity implements Serializable {
	private static final long serialVersionUID = 1L;

	@Id
	@Column(name = "ID", unique = true, nullable = false, precision = 22)
	private long id;
	
	@Version
	@Column(name = "VERSION", precision = 22)
	private long version;
	
	@Basic()
	@Column(name = "VALUE", precision = 22)
	private long value;

	public TestEntity() {
		super();
	}   
	public long getId() {
		return this.id;
	}

	public void setId(long id) {
		this.id = id;
	}   
	public long getVersion() {
		return this.version;
	}

	public void setVersion(long version) {
		this.version = version;
	}   
	public long getValue() {
		return this.value;
	}

	public void setValue(long value) {
		this.value = value;
	}
   
}
