package oracle.support.model;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import javax.ejb.Local;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.eclipse.persistence.sessions.coordination.CommandManager;
import org.eclipse.persistence.internal.sessions.coordination.RemoteConnection;
import org.eclipse.persistence.jpa.JpaHelper;

import org.eclipse.persistence.sessions.coordination.ServiceId;

/**
 * Session Bean implementation class TestFacade
 */
@Stateless(name = "TestFacade", mappedName = "TestFacade")
@Local(TestFacadeLocal.class)
public class TestFacade implements TestFacadeLocal {
	@PersistenceContext(unitName = "pu")
	private EntityManager em;

	/**
	 * Default constructor.
	 */
	public TestFacade() {
		// TODO Auto-generated constructor stub
	}

	public String readValue() {
		TestEntity testEntity = (TestEntity) em.find(TestEntity.class, 1L);
		StringBuffer buffer = new StringBuffer();
		buffer.append("test: id=" + testEntity.getId());
		buffer.append(", value=" + testEntity.getValue());
		buffer.append("\n");
		String s = buffer.toString();
		System.out.println(s);
		return s;
	}

	public String incrementAndReadValue() {
		TestEntity testEntity = (TestEntity) em.find(TestEntity.class, 1L);
		testEntity.setValue(testEntity.getValue() + 1);
		StringBuffer buffer = new StringBuffer();
		buffer.append("test: id=" + testEntity.getId());
		buffer.append(", value=" + testEntity.getValue());
		buffer.append("\n");
		String s = buffer.toString();
		System.out.println(s);
		return s;
	}

	@SuppressWarnings("unchecked")
	public Set<ServiceIdDTO> getAllRemoteServices() {
                Set<ServiceIdDTO> services = new HashSet<ServiceIdDTO>();
                 CommandManager commandManager =  JpaHelper
                                .getEntityManager(em).getServerSession().getCommandManager();
                if (commandManager != null) {
  		    Collection<RemoteConnection> remoteConnections = (Collection<RemoteConnection>)commandManager
				.getTransportManager().getConnectionsToExternalServices()
				.values();
		    for (RemoteConnection remoteConnection : remoteConnections) {
			ServiceIdDTO service = new ServiceIdDTO();
			ServiceId serviceId = remoteConnection.getServiceId();
			service.setId(serviceId.getId());
			service.setURL(serviceId.getURL());
			services.add(service);
		    }
                }
		return services;
	}

//	@SuppressWarnings("unchecked")
//	public Set<String> getAllRemoteServices() {
//		Collection<RemoteConnection> remoteConnections = (Collection<RemoteConnection>) JpaHelper
//				.getEntityManager(em).getServerSession().getCommandManager()
//				.getTransportManager().getConnectionsToExternalServices()
//				.values();
//		Set<String> services = new HashSet<String>();
//		for (RemoteConnection remoteConnection : remoteConnections) {
//			ServiceId serviceId = remoteConnection.getServiceId();
//			String service = "Id: " + serviceId.getId() + " | URL: "
//					+ serviceId.getURL();
//			services.add(service);
//		}
//		return services;
//	}

}
