package oracle.support.model.eclipselink;

import javax.naming.InitialContext;
import javax.jms.TopicConnectionFactory;
import org.eclipse.persistence.config.SessionCustomizer;
import org.eclipse.persistence.sessions.Session;
import org.eclipse.persistence.sessions.coordination.RemoteCommandManager;
import org.eclipse.persistence.sessions.coordination.jms.JMSTopicTransportManager;
import org.eclipse.persistence.sessions.server.Server;

public class JMSSessionCustomizerGF312 implements SessionCustomizer {

	@Override
	public void customize(Session session) throws Exception {
		session.getLog().write("############################## SESSION CUSTOMIZER ##############################");
		Server server = (Server) session;
		RemoteCommandManager commandMgr = (RemoteCommandManager) server
				.getCommandManager();
		JMSTopicTransportManager transportManager = (JMSTopicTransportManager) commandMgr
				.getTransportManager();
                String connectionFactoryName = transportManager.getTopicConnectionFactoryName();
                try {
                    TopicConnectionFactory connectionFactory = 
                       (TopicConnectionFactory) new InitialContext().lookup(connectionFactoryName);
                }
                catch(Exception ex) {
                    session.getLog().write("Lookup of TopicConnectionFactory \"" + connectionFactoryName + "\" failed.");
                    server.setCommandManager(null);
                    server.setShouldPropagateChanges(false);
                }
                session.getLog().flush();

		if (server.isConnected()) {
			server.getCommandManager().initialize();
		} else {
			server.login();
		}

	}

}
