package oracle.support.model.eclipselink;

import org.eclipse.persistence.config.SessionCustomizer;
import org.eclipse.persistence.sessions.Session;
import org.eclipse.persistence.sessions.coordination.RemoteCommandManager;
import org.eclipse.persistence.sessions.coordination.jms.JMSTopicTransportManager;
import org.eclipse.persistence.sessions.server.Server;

public class JMSSessionCustomizerWLS implements SessionCustomizer {

	@Override
	public void customize(Session session) throws Exception {
		session.getLog().write("############################## SESSION CUSTOMIZER ##############################");
		Server server = (Server) session;
		RemoteCommandManager commandMgr = (RemoteCommandManager) server
				.getCommandManager();
		JMSTopicTransportManager transportManager = (JMSTopicTransportManager) commandMgr
				.getTransportManager();
		String port = System.getProperty("eclipselink.coordination.localport");
		String username = System
				.getProperty("eclipselink.coordination.username");
		if (!username.equals("None")) {
			String url = "t3://"
					+ System.getProperty("eclipselink.coordination.localhost")
					+ ":" + port + "/";
			transportManager.setTopicHostUrl(url);
		}

		if (!username.equals("None")) {
			String password = System
					.getProperty("eclipselink.coordination.password");
			transportManager.setUserName(username);
			transportManager.setEncryptedPassword(password);
		}

		if (server.isConnected()) {
			server.getCommandManager().initialize();
		} else {
			server.login();
		}

	}

}
