package oracle.support.model.eclipselink;


import java.rmi.registry.LocateRegistry;

import org.eclipse.persistence.config.SessionCustomizer;
import org.eclipse.persistence.sessions.Session;
import org.eclipse.persistence.sessions.coordination.RemoteCommandManager;
import org.eclipse.persistence.sessions.coordination.TransportManager;
import org.eclipse.persistence.sessions.coordination.rmi.RMITransportManager;
import org.eclipse.persistence.sessions.server.Server;

public class RMISessionCustomizerRCF implements SessionCustomizer {

	@Override
	public void customize(Session session) throws Exception {
                Server server = (Server) session;
                String stringPort = System.getProperty("glassfish.coordination.localport");
                if (stringPort != null ) { 
		    int port = Integer.parseInt(stringPort);
   		    String url = "rmi://" 
		        + System.getProperty("glassfish.cluster.node" )
			+ ":"
			+ port
			+ "/";
		    session.getLog().write("############################## SESSION CUSTOMIZER ##############################");
		    LocateRegistry.createRegistry(port);
		    RemoteCommandManager commandMgr = (RemoteCommandManager) server.getCommandManager();
		    commandMgr.setUrl(url);
		    RMITransportManager transportManager = (RMITransportManager) commandMgr.getTransportManager();
		    transportManager.setNamingServiceType(TransportManager.REGISTRY_NAMING_SERVICE);

                }
                else {
                    session.getLog().write("The property \"glassfish.coordination.localport\" had not been set. Check support note 1296971.1 for details");
                    server.setCommandManager(null);
                    server.setShouldPropagateChanges(false);                    
                    
                }
                    if (server.isConnected() && server.shouldPropagateChanges()) {
                       server.getCommandManager().initialize();
                    }
                    else {
                        server.login();
                    }


	}

}
