package oracle.support.model.eclipselink;


import org.eclipse.persistence.config.SessionCustomizer;
import org.eclipse.persistence.sessions.Session;
import org.eclipse.persistence.sessions.coordination.RemoteCommandManager;
import org.eclipse.persistence.sessions.coordination.rmi.RMITransportManager;
import org.eclipse.persistence.sessions.server.Server;

public class RMISessionCustomizerWLS implements SessionCustomizer {

	@Override
	public void customize(Session session) throws Exception {
		session.getLog().write("############################## SESSION CUSTOMIZER ##############################");
		Server server = (Server) session;
		int port = Integer.parseInt(System.getProperty("eclipselink.coordination.localport"));
		String url = "t3://" 
				+ System.getProperty("eclipselink.coordination.localhost" )
				+ ":"
				+ port
				+ "/";

		RemoteCommandManager commandMgr = (RemoteCommandManager) server.getCommandManager();
		commandMgr.setUrl(url);
		RMITransportManager transportManager = (RMITransportManager) commandMgr.getTransportManager();
		String username = System.getProperty("eclipselink.coordination.username");
		if (username != "None") {
		   String password = System.getProperty("eclipselink.coordination.password");
		   transportManager.setUserName(username);
           transportManager.setEncryptedPassword(password);
		}           
		if (server.isConnected()) {
			server.getCommandManager().initialize();
		} else {
			server.login();
		}

	}

}
