package oracle.support.web;

import java.lang.management.ManagementFactory;
import java.util.HashSet;
import java.util.Set;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import oracle.support.model.ServiceIdDTO;
import oracle.support.model.TestFacadeLocal;

public class BackingBean {

	public String getNodeInfo() {
		return ManagementFactory.getRuntimeMXBean().getName();
	}

	public String readValue() {
		Context ctx = null;
		try {
			ctx = new InitialContext();
			TestFacadeLocal testFacade = (TestFacadeLocal) ctx
					.lookup("java:comp/env/MyTestFacade");
			return testFacade.readValue();
		} catch (NamingException ex) {
			ex.printStackTrace();
		}
		return "no bean";
	}

	public String incrementAndReadValue() {
		Context ctx = null;
		try {
			ctx = new InitialContext();
			TestFacadeLocal testFacade = (TestFacadeLocal) ctx
					.lookup("java:comp/env/MyTestFacade");
			return testFacade.incrementAndReadValue();
		} catch (NamingException ex) {
			ex.printStackTrace();
		}
		return "no bean";
	}

	public Set<ServiceIdDTO> getAllRemoteServices() {
		Context ctx = null;
		try {
			ctx = new InitialContext();
			TestFacadeLocal testFacade = (TestFacadeLocal) ctx
					.lookup("java:comp/env/MyTestFacade");
			return testFacade.getAllRemoteServices();
		} catch (NamingException ex) {
			ex.printStackTrace();
		}
		return new HashSet<ServiceIdDTO>();

	}
}
